From cl.cam.ac.uk!ken.larsen Sat Nov 22 00:19:08 1997
To: David J.C. MacKay <mackay@mrao.cam.ac.uk> 
Subject: getopt examples
From: Ken Larsen <Ken.Larsen@cl.cam.ac.uk>

Hi David

I've written the same small program twice, one time in C and one time
in C++, I've tried to make some usefull comments but don't hesitate to
ask me any questions (I'm sure whether I can answer them):

First the C++ file, I compiled it with 'g++ -o cc_options options.cc' 
---------------- options.cc -------------------
#include <iostream.h>
#include <GetOpt.h>

// options.cc 

// This is a short testprogram I wrote to understand the GetOpt class,
// see also the similar file options.c where I've written the same
// program, but in pure C whereas this is an attempt to write C++

int
main (int argc, char **argv)
{
  int debug_flag(0), compile_flag(0), size_in_bytes(0);
  int option_char, i;

  GetOpt getopt(argc, argv, "dcs:"); 
  // a instance of the GetOpt class (sic). Last arg specify that there
  // is two options which are just flags -d -c, and one option which
  // should be supplied with an argument -s <arg>
  

  
  // Invokes member function `int operator ()(void)' to get next
option
  while ((option_char = getopt ()) != EOF)
    switch (option_char)
      {
      case 'd': 
	debug_flag = 1; 
	cout << "Debug" << endl; 
	break;
      case 'c': 
	cout << "Compile" << endl; 
	break;
      case 's': 
	size_in_bytes = atoi (getopt.optarg); // optarg contains the argument
	
	cout << "size = " << size_in_bytes << endl;
	break;
      case '?': 
	cerr << "usage: " <<  argv[0] <<" [dcs<size>]" << endl;
	// maybe we should exit the program here?, well let's continue
	// it's just for fun.
      }

  // Now should all the non-option agruments have been moved the the
  // end of argv.
  cout << "Number of non-option arguments = " << argc-getopt.optind << endl;

  for(i=getopt.optind;i<argc;i++)
    cout << "Filename = " << argv[i] << endl;

  return 0;
}
-------------------------------------------------------------

Then the C file, I compiled it with 'gcc -o c_options options.c' 
---------------- options.c -------------------
#include <stdio.h>
#include <unistd.h> /* This is where getarg comes from, two useful
		       variable is also declared: 
		       optarg: Contains the argument if the option 
		               takes an argument. 
		       optind: When getopt returns EOF, then optind 
		               is the index in argv of the first 
			       argv-element that is not an option. */

/* options.cc  */

/* This is a short testprogram I wrote to understand the getopt command, */
/* see also the similar file options.cc where I've written the same */
/* program, but in C++ whereas this is an attempt to write pure C */


int
main (int argc, char **argv)
{ 
  int debug_flag=0, compile_flag=0, size_in_bytes=0;
  int option_char, i;

  /* call getopt to get the next option. Last arg to getopt specify that */
  /* there is two options which are just flags -d -c, and one option which */
  /* should be supplied with an argument -s <arg> */
  while ((option_char = getopt (argc, argv, "dcs:")) != EOF)
    switch (option_char)
      {
      case 'd': 
	debug_flag = 1; 
	printf("Debug\n"); 
	break;
      case 'c': 
	compile_flag = 1; 
	printf("Compile\n"); 
	break;
      case 's': 
	size_in_bytes = atoi (optarg); /* optarg contains the argument*/
	printf("size = %d\n",size_in_bytes); 
	break;
      case '?': fprintf (stderr,
			 "usage: %s [dcs<size>]\n", argv[0]);
      /* maybe we should exit the program here?, well let's continue
         it's just for fun. */
      
      }
  printf("Number of non-option arguments = %d\n",argc-optind);

  for(i=optind;i<argc;i++)
    printf("Filename = %s\n",argv[i]);

  return 0;
}
----------------------------------------------------------------

Hope you can use it, if not sorry for spamming your mailbox.

--Ken


